﻿using UnityEditor;
using UnityEngine;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace P4Connect
{
	/// <summary>
	/// This class hooks onto the Asset Save/Delete/Move process and makes sure that
	/// Perforce is updated accordingly. It uses the perforce connection class
	/// (which internally uses Config to retrieve the connection settings)
	/// to open a connection to the server and add the required changes (add/checkout/delete/move).
	/// </summary>
	public class AssetPostProcessor
		: UnityEditor.AssetPostprocessor
	{
		public static void OnPostprocessAllAssets (
			String [] aImportedAssets,
			String [] aDeletedAssets,
			String [] aMovedAssets,
			String [] aMovedFromAssetPaths)
		{
			if (aImportedAssets.Length > 0)
			{
				Engine.CreateAssets(aImportedAssets);
			}
			if (aDeletedAssets.Length > 0)
			{
				Engine.DeleteAssets(aDeletedAssets);
			}
			if (aMovedAssets.Length > 0)
			{
				Engine.MoveAssets(aMovedFromAssetPaths, aMovedAssets);
			}
		}
	}
}
